VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsDiskVolume"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Const MOD_ALT = &H1
Private Const MOD_CONTROL = &H2
Private Const MOD_SHIFT = &H4
Private Const MOD_WIN = &H8

' Types (Structs)
Private Type CREATESTRUCT
    lpCreateParams As Long
    hInstance As Long       ' Application instance number
    hMenu As Long
    hwndParent As Long
    cy As Long
    cx As Long
    y As Long
    x As Long
    style As Long
    lpszName As String
    lpszClass As String
    ExStyle As Long
End Type

Private Type WNDCLASS
    style As Long
    lpfnwndproc As Long     ' Pointer to Call back procedure
    cbClsextra As Long
    cbWndExtra2 As Long
    hInstance As Long       ' Application instance number
    hIcon As Long
    hCursor As Long
    hbrBackground As Long
    lpszMenuName As String
    lpszClassName As String ' Window Class Name
End Type

Private Declare Function GlobalAddAtom Lib "kernel32" Alias "GlobalAddAtomA" (ByVal lpString As String) As Long
Private Declare Function GlobalDeleteAtom Lib "kernel32" (ByVal nAtom As Long) As Long

Private Declare Function RegisterClass Lib "user32" Alias "RegisterClassA" (Class As WNDCLASS) As Long
Private Declare Function UnregisterClass Lib "user32" Alias "UnregisterClassA" (ByVal lpClassName As String, ByVal hInstance As Long) As Long
Private Declare Function CreateWindowEx Lib "user32" Alias "CreateWindowExA" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hwndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
Private Declare Function DestroyWindow Lib "user32" (ByVal hwnd As Long) As Long



Private Declare Sub FormatEx Lib "FMIFS.DLL" _
                        (ByRef DriveRoot As Byte, _
                        ByVal MediaFlag As Long, _
                        ByRef Format As Byte, _
                        ByRef Label As Byte, _
                        ByVal QuickFormat As Long, _
                        ByVal ClusterSize As Long, _
                        ByVal Callback As Long)
                        

Private Declare Sub FormatEx2 Lib "FMIFS.DLL" _
                        (ByVal pDrive As Long, _
                        ByVal dwMediaType As Long, _
                        ByVal pFileSystem As Long, _
                        ByRef pFormatEx2Param As Any, _
                        ByVal Callback As Long)
                        




' Public Events
Public Event Incomming(ByVal lngCommand As Long, ByVal lngSubAction As Long, ByVal ActionInfo As Long)
Public Event Error(ByVal ErrNum As Long, ByVal ErrDesc As String)

' Global Variables
Public myhWnd As Long
Private WndCls As WNDCLASS

Private Function HookWindow()
    On Error GoTo ErrorHandler
    
    ' Create Window
    Dim CS As CREATESTRUCT
    
    Let myhWnd = CreateWindowEx(0&, WndCls.lpszClassName, "MyDiskVolume", 0&, 0&, 0&, 0&, 0&, 0&, 0&, App.hInstance, CS)
    DiskVolume_hwnd = myhWnd
Exit Function
ErrorHandler:
    RaiseEvent Error(Err.Number, Err.Description)
End Function

Private Function UnhookWindow()
    On Error GoTo ErrorHandler
    
    ' Remove Window
    Call DestroyWindow(myhWnd)
    
    Let myhWnd = 0 ' Reset Window handle
Exit Function
ErrorHandler:
    RaiseEvent Error(Err.Number, Err.Description)
End Function

Friend Sub Receive4(ByVal lngCommand As Long, ByVal lngSubAction As Long, ByVal ActionInfo As Long)
    On Error GoTo ErrorHandler
    'DoEvents
    RaiseEvent Incomming(lngCommand, lngSubAction, ActionInfo) ' Send call back information to parent class
    DoEvents
Exit Sub
ErrorHandler:
    RaiseEvent Error(Err.Number, Err.Description)
End Sub



Public Function FormatDisk( _
                        DriveRoot As Variant, _
                        FS As FileSystem, _
                        Optional Quick As Boolean = True, _
                        Optional Label As Variant = "New volume", _
                        Optional ClusterSize As ClusterSize = FMIFS_SizeDefault, _
                        Optional TypeModeOperation As OperationType = 0) As Long

    If TypeModeOperation = 0 Then
        If Not (MsgBox("WARNING: Formating will erase ALL data on the disk." & vbCrLf & vbCrLf & "To format the disk,click OK. To quit, click CANCEL.", vbExclamation Or vbOKCancel, "Format " & DriveRoot) = vbOK) Then Exit Function
    End If
    
    Dim bytDrive()  As Byte
    Dim bytFS()     As Byte
    Dim bytLabel()  As Byte
    Dim bQuick      As Long
    Dim DevType     As MediaType

    
    bytDrive = DriveRoot & Chr(0)           ' ????
    
    Select Case FS
    Case 5 'FAT32
        bytFS = "FAT32" & Chr(0)
    Case 7 'NTFS
        bytFS = "NTFS" & Chr(0)
    End Select
    
    bytLabel = Label & Chr(0)            ' ???

    If Quick Then
        bQuick = 1
    Else
        bQuick = 0
    End If
            
            
    DevType = HardDisk
        
'FormatExSub
'FormatExFunction



    Call FormatEx(bytDrive(0), _
                  DevType, _
                  bytFS(0), _
                  bytLabel(0), _
                  bQuick, _
                  ClusterSize, _
                  AddressOf Callback.FormatExCallBack)


'Call FormatEx(byDriveRoot(0), FMIFS_HARDDISK, byFormat(0), _
      byLabel(0), QuickFormat, ClusterSize, AddressOf FMIFSCallback)


End Function


Public Function FormatDisk2( _
                        DriveRoot As Variant, _
                        FS As FileSystem, _
                        Optional Quick As Boolean = True, _
                        Optional Label As Variant = "New volume", _
                        Optional ClusterSize As ClusterSize = FMIFS_SizeDefault, _
                        Optional TypeModeOperation As OperationType = 0) As Long

    If TypeModeOperation = 0 Then
        If Not (MsgBox("WARNING: Formating will erase ALL data on the disk." & vbCrLf & vbCrLf & "To format the disk,click OK. To quit, click CANCEL.", vbExclamation Or vbOKCancel, "Format " & DriveRoot) = vbOK) Then Exit Function
    End If
    
    Dim bytDrive  As String
    Dim bytFS()     As Byte
    Dim bytLabel()  As Byte
    Dim bQuick      As Long
    Dim DevType     As MediaType
    
    
    Dim sLabel As String
    
    sLabel = Label & Chr(0)
    
    Dim vFormat As FormatEx2Param
    vFormat.nVersion = Len(vFormat)
    vFormat.pVolumeLabel = StrPtr(sLabel)
    vFormat.dwClusterSize = ClusterSize
     '&H250  '&H2&  'LenB(vFormat)
    vFormat.nMajorVersion = &H250 '0 '&H250
    vFormat.nFlags = 3
    
    bytDrive = DriveRoot & Chr(0)           ' ????
    
    Select Case FS
    Case 5 'FAT32
        bytFS = "FAT32" & Chr(0)
    Case 7 'NTFS
        bytFS = "NTFS" & Chr(0)
    End Select
    
    bytLabel = Label & Chr(0)          ' ???

    If Quick Then
        bQuick = 1
    Else
        bQuick = 0
    End If
            
            
    DevType = HardDisk
        
'FormatExSub
'FormatExFunction

Dim sDriveRoot As String
Dim sFS As String

sDriveRoot = StrConv(CStr(DriveRoot), vbUnicode)
sFS = StrConv("NTFS" & Chr(0), vbUnicode)

'sDriveRoot = DriveRoot & Chr(0)
'sDriveRoot = StrConv(CStr(DriveRoot) & Chr(0), vbUnicode)
sDriveRoot = StrConv(CStr(DriveRoot), vbUnicode)
'sDriveRoot = StrConv(CStr(DriveRoot) & Chr(0), vbFromUnicode)

Dim sFS As String
'sFS = "NTFS" & Chr(0)
'sFS = StrConv("NTFS" & Chr(0), vbUnicode)
sFS = StrConv("NTFS" & Chr(0), vbUnicode)
'sFS = StrConv("NTFS" & Chr(0), vbFromUnicode)


Dim sDriveRoot As String
Dim sFS As String

sDriveRoot = StrConv(CStr(DriveRoot), vbUnicode)
sFS = StrConv("NTFS" & Chr(0), vbUnicode)

Call FormatEx2(ByVal StrPtr(sDriveRoot), _
              FMIFS_HARDDISK, _
              ByVal StrPtr(sFS), _
              ByVal VarPtr(vFormat), _
              AddressOf Callback.FormatExCallBack)


'Call FormatEx(byDriveRoot(0), FMIFS_HARDDISK, byFormat(0), _
      byLabel(0), QuickFormat, ClusterSize, AddressOf FMIFSCallback)


End Function



Private Sub Class_Initialize()
    On Error GoTo ErrorHandler
    
    Let Callback.AppObjPtr4 = ObjPtr(Me)  ' Pointer to this class
    
'    ' Register Window Class
'    Let WndCls.style = 0
'    Let WndCls.hInstance = App.hInstance
'    Let WndCls.lpfnwndproc = CLng(Val(AddressOf Callback.FormatExCallBack))
'    Let WndCls.lpszClassName = "clsCallBackFormatEx"
'
'    Call RegisterClass(WndCls)
'
'    Call HookWindow

Exit Sub
ErrorHandler:
    RaiseEvent Error(Err.Number, Err.Description)
End Sub

Private Sub Class_Terminate()
    On Error GoTo ErrorHandler
    
    'Call UnhookWindow
    
    ' Remove Window
    'If myhWnd <> 0 Then Call DestroyWindow(myhWnd)
    
    ' Remove Window Class
    'Call UnregisterClass(WndCls.lpszClassName, App.hInstance)
Exit Sub
ErrorHandler:
    RaiseEvent Error(Err.Number, Err.Description)
End Sub

