VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsDiskVolume"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'This Class Module createtd by Sosed213 
'Version 1.0
'18:06 13.04.2012

Option Explicit

Private Declare Sub FormatEx Lib "FMIFS.DLL" _
                        (ByVal DriveRoot As Long, _
                        ByVal MediaFlag As Long, _
                        ByVal Format As Long, _
                        ByVal Label As Long, _
                        ByVal QuickFormat As Long, _
                        ByVal ClusterSize As Long, _
                        ByVal Callback As Long)
                        

Private Declare Sub FormatEx2 Lib "FMIFS.DLL" _
                        (ByVal pDrive As Long, _
                        ByVal dwMediaType As Long, _
                        ByVal pFileSystem As Long, _
                        ByRef pFormatEx2Param As Any, _
                        ByVal Callback As Long)
                        
Private Declare Function GetVolumeNameForVolumeMountPointW Lib "kernel32" (ByVal lpszVolumeMountPoint As Long, ByVal lpszVolumeName As Long, ByVal cchBufferLength As Long) As Long
Private Declare Function GetVolumePathNamesForVolumeNameW Lib "kernel32" (ByVal lpszVolumeName As Long, ByVal lpszVolumePathNames As Long, ByVal cchBufferLength As Long, ByVal lpcchReturnLength As Long) As Long

Private Declare Function GetDriveTypeW Lib "kernel32" (ByVal nDrive As Long) As Long
Private Declare Function GetLogicalDrives Lib "kernel32" () As Long


Private Declare Function QueryDosDeviceA Lib "kernel32.dll" ( _
                         ByVal lpDeviceName As String, _
                         ByVal lpTargetPath As String, _
                         ByVal ucchMax As Long) As Long

Private Declare Function QueryDosDeviceW Lib "kernel32.dll" ( _
                         ByVal lpDeviceName As Long, _
                         ByRef lpTargetPath As Long, _
                         ByVal ucchMax As Long) As Long

' Public Events
Public Event Incomming(ByVal lngCommand As Long, ByVal lngSubAction As Long, ByVal ActionInfo As Long)
Public Event Error(ByVal ErrNum As Long, ByVal ErrDesc As String)

' Global Variables
Public myhWnd As Long

Friend Sub Receive4(ByVal lngCommand As Long, ByVal lngSubAction As Long, ByVal ActionInfo As Long)
    On Error GoTo ErrorHandler
    
    Dim lPercent As Long
    Dim tmpRet As Long
    Dim tmpRetInt As Integer
    Dim tmpRetByte As Byte
    
    
    Select Case lngCommand
    Case FMIFS_Progress
        GetMem4 ByVal ActionInfo, VarPtr(lPercent)
        RaiseEvent Incomming(lngCommand, lngSubAction, lPercent)
        
    Case FMIFS_Done
        'GetMem2 ByVal ActionInfo, VarPtr(tmpRetInt)
        Win32.CopyMemory tmpRetByte, ByVal ActionInfo, 1
        RaiseEvent Incomming(lngCommand, lngSubAction, tmpRetByte)
    
    
'      Case FMIFS_StructureProgress
'         If (ActionInfo <> 0) Then
'            Win32.CopyMemory uTextOutput, ByVal ActionInfo, 8
'         End If
'      Case FMIFS_DoneWithStructure
'         If (ActionInfo <> 0) Then
'            Win32.CopyMemory uTextOutput, ByVal ActionInfo, 8
'         End If
    
    Case Else
        RaiseEvent Incomming(lngCommand, lngSubAction, ActionInfo) ' Send call back information to parent class
    End Select
    
    DoEvents
Exit Sub
ErrorHandler:
    RaiseEvent Error(Err.Number, Err.Description)
End Sub



Public Function FormatDisk( _
                        DriveRoot As Variant, _
                        FS As FileSystem, _
                        Optional Quick As QuickFormat, _
                        Optional Label As Variant = "New volume", _
                        Optional ClusterSize As ClusterSize = FMIFS_SizeDefault, _
                        Optional TypeModeOperation As OperationType = 0) As Long

    If TypeModeOperation = 0 Then
        If Not (MsgBox("WARNING: Formating will erase ALL data on the disk." & vbCrLf & vbCrLf & "To format the disk,click OK. To quit, click CANCEL.", vbExclamation Or vbOKCancel, "Format " & DriveRoot) = vbOK) Then Exit Function
    End If

    Dim sDrive      As String
    Dim sFS         As String
    Dim sLabel      As String
    Dim bQuick      As Long
    Dim FMIFS_Type  As FMIFS_MediaType

    sDrive = GetDriveRoot(DriveRoot, 1, False)

    Dim nTypeDisk As Long
    nTypeDisk = GetDriveType(GetDriveRoot(sDrive, 0, True))
    
    Select Case nTypeDisk
        Case DRIVE_REMOVABLE:   FMIFS_Type = Removable
        Case DRIVE_FIXED:       FMIFS_Type = HardDisk
        Case Else:              FMIFS_Type = HardDisk
    End Select
   
    
    Select Case FS
        Case 0: sFS = "NTFS"
        Case 1: sFS = "FAT"
        Case 2: sFS = "FAT32"
        Case 3: sFS = "exFAT"
    End Select
    
    sLabel = CStr(Label): If Len(sLabel) > 32 Then sLabel = Strings.Left(sLabel, 32)


    If Quick Then
        bQuick = 1
    Else
        bQuick = 0
    End If
            
            

    Call FormatEx(ByVal StrPtr(sDrive), _
                  FMIFS_Type, _
                  ByVal StrPtr(sFS), _
                  ByVal StrPtr(sLabel), _
                  bQuick, _
                  ClusterSize, _
                  AddressOf mDiskVolume.FormatExCallBack)
End Function





'        d:\  \\?\Volume{bea7d84a-df55-11e0-92d9-806e6f6e6963}\  .
Public Function GetDriveRoot(DriveRoot As Variant, Optional ByVal ReturnDriverMode As Long = 0, Optional ByVal EndSlash As Boolean = True) As String
    'ReturnDriverMode Code
        '0 - Return Letter
        '1 - Return MountPoint

    GetDriveRoot = ""
    
    Dim sTmp As String
    sTmp = Strings.Trim(DoReplace(CStr(DriveRoot), Chr(0), ""))
    If Len(sTmp) < 2 Then Exit Function
    
    Dim retBuf As Long, retBufSize As Long, sDrive As String, sMountPoint As String
    
    Select Case Strings.Mid(sTmp, 2, 1)
    Case ":"    'Detected driver Letter d:\
        sTmp = Strings.Left(sTmp, 2) '& "\"
        DriveRoot = sTmp
       
        Select Case ReturnDriverMode
            Case 1  'Return MountPoint
                
                sMountPoint = String(50, Chr(0))
                sDrive = CStr(sTmp) & "\"
    
                retBuf = GetVolumeNameForVolumeMountPointW(ByVal StrPtr(sDrive), ByVal StrPtr(sMountPoint), 50)
                
                If retBuf Then
                    If Len(sMountPoint) < 48 Then Exit Function
                    
                    If Strings.LCase(Strings.Mid(sMountPoint, 4, 8)) = Strings.LCase("\Volume{") Then
                        sMountPoint = Strings.Left(sMountPoint, 48)
                        
                        If EndSlash Then sMountPoint = sMountPoint & "\"
                        GetDriveRoot = sMountPoint
                        
                    End If
                End If
            Case Else 'Return Letter and other
                
                If EndSlash Then sTmp = sTmp & "\"
                GetDriveRoot = sTmp
        End Select
        
    Case "\"    'Detected \\?\Volume{bea7d84a-df55-11e0-92d9-806e6f6e6963}\  Len=48
        If Len(sTmp) < 48 Then Exit Function
        
        If Not (Strings.LCase(Strings.Mid(sTmp, 4, 8)) = Strings.LCase("\Volume{")) Then Exit Function
            
        sTmp = Strings.Left(sTmp, 48)
        DriveRoot = sTmp
        
        Select Case ReturnDriverMode
            Case 0  'Return Letter
                sDrive = String(50, Chr(0))
                
                sTmp = sTmp & "\"
                retBuf = GetVolumePathNamesForVolumeNameW(ByVal StrPtr(sTmp), ByVal StrPtr(sDrive), 50, retBufSize)
                
                If retBuf Then
                    If Not (Strings.Mid(sDrive, 2, 1) = ":") Then Exit Function
                    sDrive = Strings.Left(sDrive, 2)
                    If EndSlash Then sDrive = sDrive & "\"
                    GetDriveRoot = sDrive
                End If

            Case Else  'Return MountPoint and Other
                If EndSlash Then sTmp = sTmp & "\"
                GetDriveRoot = sTmp
        End Select


    Case Else
    
    End Select
End Function

Public Function GetDriveType(DriveRoot As Variant) As Long
    Dim nRet As Long, sTmp As String
    sTmp = GetDriveRoot(DriveRoot, 0, True)
    If (Len(sTmp) = 0) Then Exit Function
       
    GetDriveType = GetDriveTypeW(StrPtr(sTmp))

End Function

Public Function GetDriveTypeString(DriveRoot As Variant) As String
    GetDriveTypeString = ""
    Dim nRet As Long
    nRet = GetDriveType(DriveRoot)
    
    Select Case nRet
    Case DRIVE_NO_ROOT_DIR: GetDriveTypeString = "NO_ROOT_DIR"
    Case DRIVE_REMOVABLE:   GetDriveTypeString = "REMOVABLE"
    Case DRIVE_FIXED:       GetDriveTypeString = "FIXED"
    Case DRIVE_REMOTE:      GetDriveTypeString = "REMOTE"
    Case DRIVE_CDROM:       GetDriveTypeString = "CDROM"
    Case DRIVE_RAMDISK:     GetDriveTypeString = "RAMDISK"
    Case Else:              GetDriveTypeString = "UNKNOWN"
    End Select
End Function



Public Function GetDosDevice(DriveRoot As Variant) As String
    GetDosDevice = ""
    
    Dim retBuf As Long, retBufSize As Long, sTargetPatch As String, sMountPoint As String
    Dim nRet As Long, sTmp As String
    sTmp = GetDriveRoot(DriveRoot, 0, False)
    If (Len(sTmp) = 0) Then Exit Function

    sTargetPatch = String(MAX_PATH, Chr(0))
    
    nRet = QueryDosDeviceW(ByVal StrPtr(sTmp), ByVal StrPtr(sTargetPatch), MAX_PATH)
    If nRet Then
        sTargetPatch = Strings.Left(sTargetPatch, nRet - 2)
        GetDosDevice = sTargetPatch
        
    End If

'QueryDosDevice(DriveLetter & ":", strBuff, MAX_PATH)


End Function



Public Function GetPartitionNumber(DriveRoot As Variant, Optional ByVal TypeOrDiskOrPartition As Long) As Long
    ' TypeOrDiskOrPartition mode
    ' 0 - Type Device ( http://msdn.microsoft.com/en-us/library/windows/desktop/bb968801(v=vs.85).aspx )
    ' 1 - Disk Number
    ' 2 - Partition Number
    
    GetPartitionNumber = -1
    
    Dim retBuf As Long, retBufSize As Long, sTargetPatch As String, sMountPoint As String
    Dim nRet As Long, sTmp As String
    sTmp = GetDriveRoot(DriveRoot, 1, False)
    If (Len(sTmp) = 0) Then Exit Function
    
    Dim hDrive As Long
    hDrive = OpenDisk(sTmp)
    If Not (hDrive > 0) Then
        GetPartitionNumber = -2
        Exit Function
    End If

    Dim dIOCTL As Long, dwOutBytes As Long
    Dim strDevNum As STORAGE_DEVICE_NUMBER
    dIOCTL = DeviceIoControl(hDrive, IOCTL_STORAGE_GET_DEVICE_NUMBER, ByVal 0&, 0&, strDevNum, LenB(strDevNum), dwOutBytes, ByVal 0&)
    
    If dIOCTL Then
        Select Case TypeOrDiskOrPartition
            Case 0: GetPartitionNumber = strDevNum.DeviceType
            Case 1: GetPartitionNumber = strDevNum.DeviceNumber
            Case 2: GetPartitionNumber = strDevNum.PartitionNumber
        End Select
        
        Debug.Print strDevNum.DeviceType, strDevNum.DeviceNumber, strDevNum.PartitionNumber
    
    Else
        GetPartitionNumber = -3
        Exit Function
    End If
    
    
   
    Call CloseDisk(hDrive)
    
End Function




Public Function FormatDisk2( _
                        DriveRoot As Variant, _
                        FS As FileSystem, _
                        Optional Quick As Boolean = True, _
                        Optional Label As Variant = "New volume", _
                        Optional ClusterSize As ClusterSize = FMIFS_SizeDefault, _
                        Optional TypeModeOperation As OperationType = 0) As Long

    If TypeModeOperation = 0 Then
        If Not (MsgBox("WARNING: Formating will erase ALL data on the disk." & vbCrLf & vbCrLf & "To format the disk,click OK. To quit, click CANCEL.", vbExclamation Or vbOKCancel, "Format " & DriveRoot) = vbOK) Then Exit Function
    End If
    
    Dim bytDrive  As String
    Dim bytFS()     As Byte
    Dim bytLabel()  As Byte
    Dim bQuick      As Long
    Dim DevType     As FMIFS_MediaType
    
    
    Dim sLabel As String
    
    sLabel = Label & Chr(0)
    
    Dim vFormat As FormatEx2Param
    vFormat.nVersion = Len(vFormat)
    vFormat.pVolumeLabel = StrPtr(sLabel)
    vFormat.dwClusterSize = ClusterSize
     '&H250  '&H2&  'LenB(vFormat)
    vFormat.nMajorVersion = &H250 '0 '&H250
    vFormat.nFlags = 3
    
    bytDrive = DriveRoot & Chr(0)           ' ????
    
    Select Case FS
    Case 5 'FAT32
        bytFS = "FAT32" & Chr(0)
    Case 7 'NTFS
        bytFS = "NTFS" & Chr(0)
    End Select
    
    bytLabel = Label & Chr(0)          ' ???

    If Quick Then
        bQuick = 1
    Else
        bQuick = 0
    End If
            
            
    DevType = HardDisk
        
'FormatExSub
'FormatExFunction

Dim sDriveRoot As String
Dim sFS As String

sDriveRoot = StrConv(CStr(DriveRoot), vbUnicode)
sFS = StrConv("NTFS" & Chr(0), vbUnicode)

'sDriveRoot = DriveRoot & Chr(0)
'sDriveRoot = StrConv(CStr(DriveRoot) & Chr(0), vbUnicode)
sDriveRoot = StrConv(CStr(DriveRoot), vbUnicode)
'sDriveRoot = StrConv(CStr(DriveRoot) & Chr(0), vbFromUnicode)

'sFS = "NTFS" & Chr(0)
'sFS = StrConv("NTFS" & Chr(0), vbUnicode)
sFS = StrConv("NTFS" & Chr(0), vbUnicode)
'sFS = StrConv("NTFS" & Chr(0), vbFromUnicode)



sDriveRoot = StrConv(CStr(DriveRoot), vbUnicode)
sFS = StrConv("NTFS" & Chr(0), vbUnicode)

Call FormatEx2(ByVal StrPtr(sDriveRoot), _
              FMIFS_HARDDISK, _
              ByVal StrPtr(sFS), _
              ByVal VarPtr(vFormat), _
              AddressOf mDiskVolume.FormatExCallBack)


'Call FormatEx(byDriveRoot(0), FMIFS_HARDDISK, byFormat(0), _
      byLabel(0), QuickFormat, ClusterSize, AddressOf FMIFSCallback)


End Function










Public Function OpenDisk(ByVal lpszRootPathName As String) As Long

    OpenDisk = -1

    Dim hDisk As Long
    hDisk = CreateFile(lpszRootPathName, GENERIC_READ Or GENERIC_WRITE, FILE_SHARE_READ Or FILE_SHARE_WRITE, ByVal 0&, OPEN_EXISTING, 0, 0)

    If (hDisk = INVALID_HANDLE_VALUE) Then
        CloseHandle hDisk
        OpenDisk = -2 '  
        MsgBox "CreateFile() Error" & vbCrLf & vbCrLf & Err.LastDllError & " - " & GetError(Err.LastDllError), vbCritical
        Exit Function
    End If

    OpenDisk = hDisk
End Function

Public Function CloseDisk(ByVal hDisk As Long) As Boolean
    CloseDisk = CloseHandle(hDisk)
End Function









Private Sub Class_Initialize()
    On Error GoTo ErrorHandler
    
    Let mDiskVolume.AppObjPtr4 = ObjPtr(Me)  ' Pointer to this class

Exit Sub
ErrorHandler:
    RaiseEvent Error(Err.Number, Err.Description)
End Sub

Private Sub Class_Terminate()
    On Error GoTo ErrorHandler

Exit Sub
ErrorHandler:
    RaiseEvent Error(Err.Number, Err.Description)
End Sub

